/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <math.h>
#include<stdio.h>
#include <stdlib.h>
#include <device.h>
#include "I2CLCDDRV.h"

extern long Temperature; //Variable to store the true temperature
extern long Pressure; //Variable to store the true pressure
extern long Altitude; //Variable to store the true altitude
unsigned short timer1s_flag=0,timer10ms=0;
long alt[10],pres[10],temp[10],nowalt,althosei;
char ch[80];
unsigned char alt_i=0,pres_i=0,temp_i=0,mode=0;
void ReadSensorDataAndNotify(void);

CY_ISR_PROTO(ButtonISR);

CY_ISR(isr1_handler)
{
    /*  Place your Interrupt code here. */
    /* `#START isr_1_Interrupt` */
    Timer_1_ClearInterrupt(Timer_1_INTR_MASK_TC);
    isr_1_ClearPending(); 
    if(timer1s_flag==0){
    timer10ms++;
        if(timer10ms>=100){
            timer1s_flag=1;
            timer10ms=0;
        }
    }
}

void  get_uart_nom()
{
    char numin,crget;
    unsigned short col;
    char num0[10];
    col=0;
    crget=0;
    UART_PC_UartPutString("INPUT NOW ALT NUM & CR END\r\n");

        while(crget==0){
            numin = UART_PC_UartGetChar();
            if( (numin >=0x30) && (numin <=0x38)){            //モード数字検出
                num0[col]=numin;
                col++;
                    sprintf(ch,"%d",numin-0x30);
                    UART_PC_UartPutString(ch);

                
                if(col>=9)col=8;
            }
            if(numin==0x0d){
                crget=1;
                num0[col]=0;
                nowalt=atol( num0 );
                sprintf(ch,"\r\nALT=%ldm\r\n",nowalt);
                UART_PC_UartPutString(ch);
                althosei=nowalt-Altitude/10;

                
            }
        }        
        UART_PC_UartPutString("\r\n");

    
    
}



void pc_cmd_get()
{
    char pccmd;


    pccmd = UART_PC_UartGetChar();
        if(pccmd!=0){
        if( (pccmd>=0x30) && (pccmd<=0x38)){            //モード数字検出
            
            if(pccmd==0x30){
                UART_PC_UartPutString("MODE=0[default] CSV MODE \r\n");
                mode=0;
            }
            if(pccmd==0x31){
                UART_PC_UartPutString("MODE=1 TEXT MODE \r\n");
                mode=1;
            }

        }
        pccmd&=0xdf;        //アルファベット大文字変換する。

        if( pccmd=='A'){
            UART_PC_UartPutString("NOW ALT[m] SET \r\n NOM[cr]");
                get_uart_nom();
                
            
        
        }

        if( pccmd=='H'){
        UART_PC_UartPutString("\r\n***********************************************************************************\r\n");
        UART_PC_UartPutString("BMP180 SENSOR VIEWER VER 1.0 \r\n");
        UART_PC_UartPutString("COMMAND \r\n");
        UART_PC_UartPutString("NOM 1-9 & [R]eset [H]elp\r\n");
        UART_PC_UartPutString("0 CSV MODE\r\n");
        UART_PC_UartPutString("1 TEXT MODE\r\n");
        UART_PC_UartPutString("\r\n");
     UART_PC_UartPutString("10SEC COUNT,Temperature('C),Air Pressure(hPa),Altitude(m)\r\n");

        }

        if( pccmd=='T'){
            UART_PC_UartPutString("TEST \r\n");
            }
        
        }//PCコマンド監視END
}



int main()
{
    unsigned short i;
    long alt_sum,temp_sum,pres_sum,count=0;
    isr_1_StartEx(isr1_handler) ;
        I2CM_Start();
        Timer_1_Start();
        UART_PC_Start();
    UART_PC_UartPutString("BMP180 SENSOR VIEWER VER 1.0 \r\n");

    CyGlobalIntEnable; /* Enable global interrupts. */

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
//	LCD_Init();
//    LCD_Clear();
//   LCD_SetPos(0, 0);
//    sprintf(ch,"%X",0x12345678);
//	LCD_Puts(ch);
//    LCD_SetPos(0, 1);
//	LCD_Puts("JOY");
//    CyDelay(500);
    ReadAndCalculateSensorData();
for(i=0;i<10;i++){
alt[i]=Altitude;
pres[i]=Pressure;
temp[i]=Temperature;
}
i=0;
    UART_PC_UartPutString("10SEC COUNT,Temperature('C),Air Pressure(hPa),Altitude(m)\r\n");
    for(;;)
    {
         pc_cmd_get();
        if(timer1s_flag!=0){
                ReadAndCalculateSensorData();
                alt[i]=Altitude;
                pres[i]=Pressure;
                temp[i]=Temperature;
                i++;
                timer1s_flag=0;
                if(i>=10){
                        alt_sum=0;
                        temp_sum=0;
                        pres_sum=0;
                    
                    for(i=0;i<10;i++){
                        alt_sum+=alt[i];
                        temp_sum+=temp[i];
                        pres_sum+=pres[i];
                    }
                    count++;
                    i=0;
                sprintf(ch,"%ld,",count);
                 UART_PC_UartPutString(ch);
                if(mode==0){                    
                    sprintf(ch,"%4.2f,",(float) pres_sum/1000);
                    UART_PC_UartPutString(ch);
                    sprintf(ch,"%3.1f,",(float)temp_sum/100);
                    UART_PC_UartPutString(ch);
                    sprintf(ch,"%5.1f\r\n",(float)alt_sum/100+althosei);
                    UART_PC_UartPutString(ch);
                }
                if(mode==1){                    
                    sprintf(ch,"AIR PRESS %4.2fhPa,",(float) pres_sum/1000);
                    UART_PC_UartPutString(ch);
                    sprintf(ch,"TEMP %3.1f'C,",(float)temp_sum/100);
                    UART_PC_UartPutString(ch);
                    sprintf(ch,"ALT %5.1fm\r\n",(float)alt_sum/100+althosei);
                    UART_PC_UartPutString(ch);
                }
            }
        }
    }
}

/* [] END OF FILE */
